from __future__ import print_function
import sys
sys.path.append('../../..')
sys.path.append('../Example10')
import demoapp
import meshgen
from mupif import *

app = demoapp.thermal('inputT11.in','.')
print(app.getApplicationSignature())

solver = app.solveStep(TimeStep.TimeStep(0,1)) 
coarseField = app.getField(FieldID.FID_Temperature, 1.0)
coarseField.field2VTKData().tofile('thermal11-coarse')
coarseField.field2Image2D(title='Coarse mesh', fileName='thermal11-coarse.png')

fineMesh = meshgen.meshgen((0.,0.), (5., 1.), 18, 9, tria=True)
fineField = Field.Field(fineMesh, FieldID.FID_Temperature, ValueType.Scalar, 'C', None, values=None)
 

for i in range(fineMesh.getNumberOfVertices()):
    coord = (fineMesh.getVertex(i).getCoordinates())
    t = coarseField.evaluate(coord)
    fineField.setValue(i,t)

fineField.field2VTKData().tofile('thermal11-fine')
fineField.field2Image2D(title='Fine mesh', fileName='thermal11-fine.png')

import time
time.sleep(10)
